unit UcalcForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Math, Dialogs, StdCtrls, UMainForm, UFreqCalc, UDMCumFreq, UCumFreqUtils;

type
  TCalcForm = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Edit7: TEdit;
    Edit8: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Edit9: TEdit;
    Edit10: TEdit;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Edit11: TEdit;
    Edit12: TEdit;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Edit13: TEdit;
    Edit14: TEdit;
    Label18: TLabel;
    procedure FormShow(Sender: TObject);
    procedure Edit7Click(Sender: TObject);
    procedure Edit4Exit(Sender: TObject);
    procedure Edit5Exit(Sender: TObject);
    procedure CalcFrequent;
    procedure ReadParam;
    procedure CalcVal;
    procedure NormalCalc(CumulFreq:real);
    procedure MaxMin;
    procedure FormHide(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Edit1Enter(Sender: TObject);
    procedure Edit4Enter(Sender: TObject);
    procedure Edit5Enter(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  CalcForm: TCalcForm;
  CumFr, ValX : real;
  ValXX, Bound : real;
  CumFrU, CumFrL : real;
  ValXU, ValXL : real;
  ValOfX, CFBP : real;
  Exponent, DevSt: real;
  RetPerU        : real;
  Ave, StE       : real;
  TmpInt : integer;
  NrDat : integer;

  implementation

{$R *.dfm}


procedure TCalcForm.FormShow(Sender: TObject);
begin
  Edit1.Text:='';
  Edit2.Text:='';
  Edit3.Text:='';
  Edit4.Text:='';
  Edit5.Text:='';
  Edit9.Text:='';
  Edit10.Text:='';
  Edit13.Text:='';
  Edit14.Text:='';
  if Method=61 then
  begin
    Edit4.Enabled:=false;
    Edit5.Enabled:=false;
    Label4.Enabled:=false;
    Label5.Enabled:=false;
    Label6.Enabled:=false;
    Label13.Enabled:=false;
    Label14.Enabled:=false;
    Edit6.Text:=' n.a';
    Edit11.Text:=' n.a';
    Edit12.Text:=' n.a';
    Label18.Enabled:=false;
  end
  else
  begin
    Edit4.Enabled:=true;
    Edit5.Enabled:=true;
    Label4.Enabled:=true;
    Label5.Enabled:=true;
    Label6.Enabled:=true;
    Label13.Enabled:=true;
    Label14.Enabled:=true;
    Edit6.Text:='';
    Edit11.Text:='';
    Edit12.Text:='';
    Label18.Enabled:=true;
  end;
end;


procedure TCalcForm.Edit7Click(Sender: TObject);
var Diff, Val3 : real;
begin
  Try
    ValOfX:=MainForm.StringToFloat(Edit1.Text);
    Except on E: Exception do
    begin
      Showmessage ('The value is not a valid real');
      exit;
    end;
  end;
  ValOfX:=ValOfX-Minim;
  CalcFrequent;
  if CumFr<0 then CumFr:=0;
  if CumFr>1 then CumFr:=1;
  Edit2.Text:=FloatToStr(CumFr);
  Edit3.Text:=FloatToStr(1/(1-CumFr));
  Val3:=1/(1-CumFr);
  Diff := 1/(1-CumFrU) - 1/(1-CumFrL);
  Edit9.Text:=FloatToStr(Val3-0.33*Diff);
  Edit10.Text:=FloatToStr(Val3+0.66*Diff);
  Edit13.Text:=FloatToStr(CumFrL);
  Edit14.Text:=FloatToStr(CumFrU);
end; {TCalcForm.Edit7Click}


procedure TCalcForm.Edit4Exit(Sender: TObject);
begin
  Try
    CumFr:=MainForm.StringToFloat(Edit4.Text);
    Except on E: Exception do
    begin
      Showmessage ('The frequency is not a valid integer');
      exit;
    end;
  end;
  if (CumFr<=0.000001) or (CumFr>=0.999999) then
  begin
    Showmessage ('The frequency must be >0.000001 and <0.999999');
    exit;
  end;
  CalcVal;
  Edit6.Text:=FloatToStr(ValX);
  Edit5.Text:=FloatToStr(1/(1-CumFr));
  Edit11.Text:=FloatToStr(ValXL);
  Edit12.Text:=FloatToStr(ValXU);
end; {TCalcForm.Edit4Exit}


procedure TCalcForm.Edit5Exit(Sender: TObject);
var RP:real;
begin
  Try
    RP:=MainForm.StringToFloat(Edit5.Text);
    Except on E: Exception do
    begin
      Showmessage ('The return period is not a valid real');
      exit;
    end;
  end;
  if (RP<=0.000001) or (RP>=100000) then
  begin
    Showmessage ('The return period must be >0.000001 and <100000');
    exit;
  end;
  CumFr:=1-(1/RP);
  CalcVal;
  Edit6.Text:=FloatToStr(ValX);
  Edit4.Text:=FloatToStr(CumFr);
  Edit11.Text:=FloatToStr(ValXL);
  Edit12.Text:=FloatToStr(ValXU);
end; {TCalcForm.Edit5Exit}


procedure TCalcForm.CalcFrequent;
{-------------------------------}
var AuxVar,Term1,Term2,Term3,Term4,Term5,TermSum : real;
    TmpR, {TmpL,} MagRed, MagTrf, MagTrSq : real;
    km, mm : integer;
begin
  Try
    ValOfX:=MainForm.StringToFloat(Edit1.Text);
    Except on E: Exception do
    begin
      Showmessage ('The value is not a valid real');
      exit;
    end;
  end;
  DMCumFreq.FileName:=ChangeFileExt(DMCumFreq.FileName,'.inp');
  DmCumFreq.ReadInputFile;
  ReadParam;
  ValOfX:=ValOfX-Minim+0.0001;
  if ValOfX <= 0 then ValOfX := 0.001;
  
    if Method=1 then
    begin
      TmpR  := exp(Exponent*ln(ValOfX));
      CumFr := Slope*TmpR + Inter;
    end;
    if Method=2 then
    begin
      TmpR  := exp(Exponent*ln(ValOfX));
      CumFr := exp(Slope*TmpR+Inter);
    end;
    if Method=3 then
    begin
      TmpR  := exp(Exponent*ln(ValOfX));
      CumFr := 1-exp(-Slope*TmpR-Inter);
    end;  
    if Method=4 then
       CumFr := exp(-exp(-Slope*ValOfX-Inter));
    if Method=5 then
       CumFr := 1 - exp(-exp(-Slope*ValOfX-Inter));
    if Method=6 then
    begin
      TmpR  := exp(ln(ValOfX));
      CumFr := 1-exp(-Slope*TmpR);
    end;
    if Method=7 then
    begin
      if ValOfX>Bpoint-Minim then
        CumFr := 1 - exp(-exp(-SlopeB*ValOfX-InterB))
      else
        CumFr := 1 - exp(-exp(-SlopeA*ValOfX-InterA));
    end;
    if Method=8 then
    begin
      if ValOfX>Bpoint-Minim then
      begin
        TmpR := 1+exp(SlopeB*ValOfX+InterB);
        CumFr := 1/TmpR;
      end else
      begin
        TmpR := 1+exp(SlopeA*ValOfX+InterA);
        CumFr := 1/TmpR;
      end;
    end;
    if Method=9 then
    begin
      if ValOfX>Bpoint-Minim then
      begin
         TmpR  := SlopeB*ValOfX+InterB;
         CumFr := exp(-exp(-TmpR));
      end else
      begin
         TmpR  := SlopeA*ValOfX+InterA;
         CumFr := exp(-exp(-TmpR));
      end;
    end;
    if Method=10 then
    begin
      if ValOfX>Bpoint-Minim then
      begin
        CumFr := 1+exp(SlopeB*ValOfX+InterB);          {Logistic}
        CumFr := 1/CumFr;
      end else
      begin
        CumFr := SlopeA*ValOfX + InterA;              {Gumbel mirror}
        CumFr := exp(-CumFr);
        CumFr := exp(-CumFr);
        CumFr := 1-CumFr;
      end;
    end;
    if Method=11 then
    begin
      if ValOfX>Bpoint-Minim then
      begin
        CumFr := SlopeB*ValOfX + InterB;
        CumFr := exp(-exp(-CumFr))                     {Gumbel standard}
      end else
      begin
        CumFr := SlopeA*ValOfX + InterA;               {Gumbel Mirror}
        CumFr := exp(-CumFr);
        CumFr := exp(-CumFr);
        CumFr := 1-CumFr;
      end;
    end;
    if Method=12 then
    begin
      if ValOfX>Bpoint-Minim then
      begin
        CumFr := 1+exp(SlopeB*ValOfX+InterB);          {Logistic}
        CumFr := 1/CumFr;
      end else
      begin
        CumFr := SlopeA*ValOfX + InterA;
        CumFr := exp(-exp(-CumFr))                     {Gumbel}
      end;
    end;
    if Method=13 then
    begin
      if ValOfX>Bpoint-Minim then
      begin
        CumFr := SlopeB*ValOfX + InterB;               {Gumbel Mirror}
        CumFr := exp(-CumFr);
        CumFr := exp(-CumFr);
        CumFr := 1-CumFr;
      end else
      begin
        CumFr := SlopeA*ValOfX + InterA;
        CumFr := exp(-exp(-CumFr))                     {Gumbel}
      end;
    end;
    if Method=14 then
    begin
      if ValOfX>Bpoint-Minim then
      begin
        CumFr := SlopeB*ValOfX + InterB;              {Gumbel Mirror}
        CumFr := exp(-CumFr);
        CumFr := exp(-CumFr);
        CumFr := 1-CumFr;
      end else
      begin
        CumFr := 1+exp(SlopeA*ValOfX+InterA);          {Logistic}
        CumFr := 1/CumFr;
      end;
    end;
    if Method=15 then
    begin
      if ValOfX>Bpoint-Minim then
      begin
        CumFr := SlopeB*ValOfX + InterB;
        CumFr := exp(-exp(-CumFr))                {Gumbel}
      end else
      begin
        CumFr := 1+exp(SlopeA*ValOfX+InterA);     {Logistic}
        CumFr := 1/CumFr;
      end;
    end;
    if Method=16 then
    begin
      if ValOfX>Bpoint-Minim then
         CumFr := 1 - exp(-SlopeB*ValOfX-InterB)       {Poisson}
      else
      begin
        CumFr := SlopeA*ValOfX + InterA;
        CumFr := exp(-exp(-CumFr))                     {Gumbel}
      end;
    end;
    if Method=17 then
    begin
      if ValOfX>Bpoint-Minim then
         CumFr := 1 - exp(-SlopeB*ValOfX-InterB)       {Poisson}
      else
      begin
        CumFr := SlopeA*ValOfX + InterA;               {Gumbel Mirror}
        CumFr := exp(-CumFr);
        CumFr := exp(-CumFr);
        CumFr := 1-CumFr;
      end;
    end;
    if Method=18 then
    begin
      if ValOfX>Bpoint-Minim then
         CumFr := 1 - exp(-SlopeB*ValOfX-InterB)       {Poisson}
      else
      begin
        CumFr := 1+exp(SlopeA*ValOfX+InterA);          {Logistic}
        CumFr := 1/CumFr;
      end;
    end;

    if (Method>19) and (Method<30) then
    begin
      AuxVar:=0;
      if Method=20 then AuxVar := ValOfX;
      if Method=21 then AuxVar := ValOfX;
      if Method=22 then AuxVar := ln(ValOfX);
      if Method=23 then AuxVar := ln(ValOfX);
      if Method=24 then AuxVar := sqrt(ValOfX);
      if Method=25 then AuxVar := sqr(ValOfX);
      if Method=26 then AuxVar := exp(Exponent*ln(ValOfX));
      MagRed    := (AuxVar-MagAv)/StDev;
      MagTrf    := 1/(1+0.23165*MagRed);
      MagTrSq   := MagTrf*MagTrf;
      Term1     := 0.31938*MagTrf;
      Term2     :=-0.35656*MagTrSq;
      Term3     := 1.78148*MagTrf*MagTrSq;
      Term4     :=-1.82126*MagTrSq*MagTrSq;
      Term5     := 1.33027*MagTrf*MagTrSq*MagTrSq;
      TermSum   := Term1+Term2+Term3+Term4+Term5;
      AuxVar    := exp(-MagRed*MagRed/2)/sqrt(2*Pi);
      CumFr := 1-AuxVar*TermSum;
      if (TermSum<0) then CumFr:=0.001;
    end;

    if Method=31 then                         {Burr}
    begin
      TmpR:=ln(Inter31/(exp(AA1*ln(ValOfX))+Inter31));
      CumFr := 1-exp(Slope31*TmpR+Bur);
    end;
    if Method=32 then                         {Dagum}
    begin
      TmpR:=ln(Inter32/(exp(AA1*ln(ValOfX))+Inter32));
      CumFr := exp(Slope32*TmpR+Dag);
    end;
    if Method=34 then
    begin
      AA2:=ValOfX;
      if Small then AA2:=(ValOfX+1);
      TmpR:=AA1*ln(AA2);
      TmpR:=exp(BE1*TmpR)-1;
      CumFr := 1 - exp(Slope34*TmpR);
      if CumFr<0.001 then CumFr:=0.001;
    end;
    if Method=36 then                         {Kumaraswamy}
    begin
      TmpR  := 1-exp(Expon36*ln(ValOfX/MaxVal));
      CumFr := 1 - exp(Slope36*ln(TmpR));
    end;
    if Method=51 then
    begin
      TmpR  := exp(Exponent*ln(ValOfX));
      CumFr := exp(-exp(-Slope*TmpR-Inter));
    end;
    if Method=52 then
    begin
      TmpR  := exp(Exponent*ln(ValOfX));
      CumFr := 1 - exp(-exp(-Slope*TmpR-Inter));
    end;
    if Method=53 then
    begin
      TmpR  := 1+exp(Slope*ValOfX+Inter);
      CumFr := 1/TmpR;
    end;
    if Method=54 then                         {log logistic}
    begin
      TmpR  := 1+exp(Slope*ln(ValOfX)+Inter);
      CumFr := 1/TmpR;
    end;
    if Method=55 then                         {exp. logistic}
    begin
      TmpR  := 1+exp(Slope*exp(Exponent*ln(ValOfX))+Inter);
      CumFr := 1/TmpR;
    end;
    if Method=70 then
    begin
      if ValOfX>Bpoint-Minim then
        TmpR := 1+exp(SlopeB*exp(ExponB*ln(ValOfX))+InterB)
      else
        TmpR := 1+exp(SlopeA*exp(ExponA*ln(ValOfX))+InterA);
      CumFr := 1/TmpR;
    end;
    if Method=71 then
    begin
      if ValOfX>Bpoint-Minim then
      begin
        TmpR := exp(ExponB*ln(ValOfX));
        TmpR := SlopeB*TmpR+InterB
      end else
      begin
        TmpR := exp(ExponA*ln(ValOfX));
        TmpR := SlopeA*TmpR+InterA;
      end;
      CumFr := exp(-exp(-TmpR));
    end;

    if Method=72 then
    begin
      if ValOfX>Bpoint-Minim then
      begin
        TmpR := exp(ExponB*ln(ValOfX));
        TmpR := -SlopeB*TmpR - InterB;
      end else
      begin
        TmpR := exp(ExponA*ln(ValOfX));
        TmpR := -SlopeA*TmpR - InterA;
      end;
      CumFr := 1 - exp(TmpR);
    end;

    if Method=80 then
    begin
      if ValOfX>Bpoint-Minim then
      begin
        TmpR := exp(ExponB*ln(ValOfX));
        TmpR := SlopeB*TmpR+InterB;
        CumFr := exp(-exp(-TmpR));
      end else
      begin
        TmpR := 1+exp(SlopeA*exp(ExponA*ln(ValOfX))+InterA);
        CumFr := 1/TmpR;
      end;
    end;

    if Method=81 then
    begin
      if ValOfX>Bpoint-Minim then
      begin
        TmpR := exp(ExponB*ln(ValOfX));
        TmpR := -SlopeB*TmpR - InterB;
        CumFr := 1 - exp(TmpR);
      end else
      begin
        TmpR := 1+exp(SlopeA*exp(ExponA*ln(ValOfX))+InterA);
        CumFr := 1/TmpR;
      end;
    end;

    if Method=82 then
    begin
      if ValOfX>Bpoint-Minim then
      begin
        TmpR := 1+exp(SlopeB*exp(ExponB*ln(ValOfX))+InterB);
        CumFr := 1/TmpR;
      end else
      begin
        TmpR := exp(ExponA*ln(ValOfX));
        TmpR := SlopeA*TmpR+InterA;
        CumFr := exp(-exp(-TmpR));
      end;
    end;

    if Method=83 then
    begin
      if ValOfX>Bpoint-Minim then
      begin
        TmpR := exp(ExponB*ln(ValOfX));
        TmpR := -SlopeB*TmpR - InterB;
        CumFr := 1 - exp(TmpR);
      end else
      begin
        TmpR := exp(ExponA*ln(ValOfX));
        TmpR := SlopeA*TmpR+InterA;
        CumFr := exp(-exp(-TmpR));
      end;
    end;

    if Method=84 then
    begin
      if ValOfX>Bpoint-Minim then
      begin
        TmpR := 1+exp(SlopeB*exp(ExponB*ln(ValOfX))+InterB);
        CumFr := 1/TmpR;
      end else
      begin
        TmpR := exp(ExponA*ln(ValOfX));
        TmpR := -SlopeA*TmpR - InterA;
        CumFr := 1 - exp(TmpR);
      end;
    end;

    if Method=85 then
    begin
      if ValOfX>Bpoint-Minim then
      begin
        TmpR := exp(ExponB*ln(ValOfX));
        TmpR := SlopeB*TmpR+InterB;
        CumFr := exp(-exp(-TmpR));
      end else
      begin
        TmpR := exp(ExponA*ln(ValOfX));
        TmpR := -SlopeA*TmpR - InterA;
        CumFr := 1 - exp(TmpR);
      end;
    end;

    if Method=56 then                         {Fisk}
       CumFr := 1-1/(1+exp(Slope*(ln(ValOfX/Inter))));

    if Method=57 then                         {Weibull}
    begin
      TmpR :=exp(-Inter/Slope);               {labda}
      TmpR :=Slope*ln(ValOfX/TmpR);          {k ln (x/labda) = ln(-ln(1-F))}
      TmpR := exp(TmpR);                      {-ln(1-F)}
      CumFr:=1-exp(-TmpR);
    end;
    if Method=58 then                         {Frechet}
    begin
      TmpR := (ValOfX+Minim-Bound)/Exp(-Inter/Slope);
      if TmpR>0 then
      begin
        TmpR := exp(Slope*ln(TmpR));
        CumFr:= exp(-TmpR);
      end else
        CumFr:= 0;
    end;
    if Method=33 then                         {F-T type 3 mirr.}
    begin
      TmpR := Bound-ValOfX-Minim;
      if TmpR>0 then
      begin
        TmpR := TmpR/Exp(-Inter/Slope);
        TmpR := exp(Slope*ln(TmpR));
        CumFr:= 1-exp(-TmpR);
      end else CumFr:=0;
    end;
    if Method=35 then                         {Frechet mirr.}
    begin
      TmpR := (ValOfX+Minim-Bound)/Exp(-Inter/Slope);
      if TmpR>0 then
      begin
        TmpR := exp(Slope*ln(TmpR));
        CumFr:= 1-exp(-TmpR);
      end else
        CumFr:= 0;
    end;
    if Method=59 then                         {F-T type 3}
    begin
      TmpR := Bound-ValOfX-Minim;
      if TmpR>0 then
      begin
        TmpR := TmpR/Exp(-Inter/Slope);
        TmpR := exp(Slope*ln(TmpR));
        CumFr:= exp(-TmpR);
      end else CumFr:=0;
    end;
    if Method=60 then
    begin
      TmpR :=exp(-Inter/Slope);               {labda}
      TmpR :=Slope*ln(ValOfX/TmpR);          {k ln (x/labda) = ln(-ln(1-F))}
      TmpR := exp(TmpR);                      {-ln(1-F)}
      CumFr:=exp(-TmpR);
    end;                                      {Mirr. Weibull}
    if Method=61 then                         {Erlang}
    begin
      TmpR:=0;
      Nfact:=1;
      km:=round(Inter61);
      for mm:=0 to km-1 do
      begin
        if mm=0 then Nfact:=1
           else Nfact:= Nfact * mm;
        TmpR:=TmpR +
             (1/Nfact)*(exp(-ValOfX/Slope61)*exp(mm*(ln(ValOfX/Slope61))));
      end;
      CumFr := 1- TmpR;
    end;
    if Method=62 then                                {Student's with 1 d.f}
    begin
      TmpR := (ValOfX+Minim-MagAv)/StDev ;                {Y, redX}
      CumFr := 0.5+arctan(TmpR)/pi;
    end;
    if Method=63 then                                {Student's with 2 d.f}
    begin
      TmpR:= sqrt(2+sqr((ValOfX+Minim-MagAv)/StDev));
      TmpR:= ((ValOfX+Minim-MagAv)/StDev)/TmpR;
      CumFr:=0.5*(1+TmpR);
    end;
    if Method=64 then
    begin
      TmpR:= Slope*ValOfX+Inter;
      CumFr := (1/pi)*arctan(TmpR)+0.5;
    end;
    if Method=65 then
    begin
      TmpR := exp(Exponent*ln(ValOfX));
      TmpR:= Slope*TmpR+Inter;
      CumFr := (1/pi)*arctan(TmpR)+0.5;
    end;
    if Method=66 then
    begin
      TmpR  := exp(Exponent*ln(ValOfX));
      CumFr := exp(-Slope*TmpR-Inter);
    end;
    if Method=67 then                           {GEV}
    begin
      TmpR := Exponent*(ValOfX-Ave)/StE;
      if (1+TmpR)>0 then
         TmpR:=(-1/Exponent)*ln(1+TmpR)
      else
         TmpR:=0;
      TmpR:=exp(TmpR);
      CumFr := exp(-(TmpR));
    end;
    if Method=68 then                           {Laplace}
    begin
      if ValOfX<BoundL then
         CumFr:=0.5*exp((ValOfX-BoundL)/BB1)
      else
         CumFr:=1-0.5*exp((BoundL-ValOfX)/BB2);
    end;
    if Method=69 then                           {Rayleigh}
    begin
      TmpR:=exp(Expon69*ln(ValOfX));
      CumFr:=1-exp(-TmpR/Slope69);
    end;
    if Method=73 then                           {Laplace generalized}
    begin
      BoundL:=exp(Expon73A*ln(BoundL));
      TmpR:=exp(Expon73A*ln(ValOfX));
      if TmpR<BoundL then
         CumFr:=0.5*exp((TmpR-BoundL)/BB1)
      else
      begin
        TmpR:=exp(Expon73B*ln(ValOfX));
        CumFr:=1-0.5*exp((BoundL-TmpR)/BB2);
      end;
    end;

    if CumFr<=0 then CumFr:=0.0000001;
    if CumFr>=1 then CumFr:=0.9999999;
    NrDat:=DMCumFreq.NrOfData;
    DevSt:= (1/NrDat)*exp(0.5*ln((CumFr)*(1-(CumFr))*NrDat));
    CumFrU := CumFr + 3.4*DevSt*(1-CumFr);
    CumFrL := CumFr - 3.4*DevSt*CumFr;
    if CumFrL<0 then CumFrL:=0;
    TmpR := 1/(1-CumFr);
    RetPerU:=TmpR+1.7*DevSt/sqr(1-CumFr);
    if CumFrL<0 then CumFrL:=0;
    if CumFrU>1 then CumFrU:=1;

end; {TCalcForm.CalcFrequent}


procedure TCalcForm.ReadParam;
var TmpR : real; HlpStr:string[5];
begin
  DMCumFreq.FileName := ChangeFileExt (DMCumFreq.FileName,'.aux');
  AssignFile(OutFile,DmCumFreq.FileName);
  {$I-} Reset(OutFile); {$I+}
  readln (OutFile,HlpStr);
  if HlpStr=' Para' then readln (OutFile,Method)
  else Method:=strtoint(HlpStr);
  if (Method<6) or (Method>50) or (Method=33) or (Method=35) then
  if Method<70 then if (Method<>36) and (Method<>61) and (Method<>62)
     and (Method<>63) then
  begin
    readln (OutFile,Slope);
    readln (OutFile,Inter);
    if Method=3 then
    begin
      readln (OutFile,Exponent);
      Expon3:=Exponent;
    end;
    if Method=6 then readln (OutFile,Slope);
    if Method=51 then
    begin
      readln (OutFile,Exponent);
      Expon51:=Exponent;
    end;
    if Method=52 then
    begin
      readln (OutFile,Exponent);
      Expon52:=Exponent;
    end;
    if Method=55 then
    begin
      readln (OutFile,Exponent);
      Expon55:=Exponent;
    end;
    if Method=58 then
    begin
       readln (OutFile,Bound);
       Bound58:=Bound;
    end;
    if Method=35 then
    begin
      readln (OutFile,Bound);
      Bound35:=Bound;
    end;
    if Method=59 then
    begin
      readln (OutFile,Bound);
      Bound59:=Bound;
    end;
    if Method=33 then
    begin
      readln (OutFile,Bound);
      Bound33:=Bound;
    end;
    if Method=65 then
    begin
      readln (OutFile,Exponent);
      Expon65:=Exponent;
    end;
    if Method=66 then
    begin
      readln (OutFile,Exponent);
      Expon66:=Exponent;
    end;
    if Method=67 then
    begin
      readln (OutFile,Exponent);
      readln (OutFile,Ave);
      readln (OutFile,StE);
      Expon67:=Exponent;
      MagAv67:=Ave;
      StErr67:=StE;
    end;
    if Method=68 then
    begin
      readln (OutFile,BoundL);
      readln (OutFile,BB1);
      readln (OutFile,BB2);
    end;
  if Method=69 then
  begin
    readln (OutFile,Expon69);
    readln (OutFile,Slope69);
  end;
  end;
  if Method=36 then
  begin
    readln (OutFile,MaxVal);
    readln (OutFile,Expon36);
    readln (OutFile,Slope36);
  end;
  if Method=61 then
  begin
    readln (OutFile,Slope61);
    readln (OutFile,Inter61);
  end;
  if (Method>19) and (Method<30) then
  begin
    readln (OutFile,MagAv);
    readln (OutFile,StDev);
    if Method=26 then readln (OutFile,Exponent);
    if Method=20 then
    begin
      MagAv0:=MagAv;
      StDev0:=StDev;
    end;
    if Method=21 then
    begin
      MagAv1:=MagAv;
      StDev1:=StDev;
    end;
    if Method=22 then
    begin
      MagAv2:=MagAv;
      StDev2:=StDev;
    end;
    if Method=23 then
    begin
      MagAv3:=MagAv;
      StDev3:=StDev;
    end;
    if Method=24 then
    begin
      MagAv4:=MagAv;
      StDev4:=StDev;
    end;
    if Method=25 then
    begin
      MagAv5:=MagAv;
      StDev5:=StDev;
    end;
    if Method=26 then
    begin
      MagAv6:=MagAv;
      StDev6:=StDev;
      Expon26:=Exponent;
    end;
  end;
  if Method=31 then                               {Burr}
  begin
    readln (OutFile,Inter31);
    readln (OutFile,AA1);
    AA1B := AA1;
    readln (OutFile,Slope31);
    readln (OutFile,BE1);
    BE1B := BE1;
    readln (OutFile,Bur);
  end;
  if Method=32 then                               {Dagum}
  begin
    readln (OutFile,Inter32);
    readln (OutFile,AA1);
    AA1D := AA1;
    readln (OutFile,Slope32);
    readln (OutFile,BE1);
    BE1D := BE1;
    readln (OutFile,Dag);
  end;

  if Method=34 then                               {Gompertz}
  begin
    readln (OutFile,Fac);
    if Fac=1 then Small:=true else Small:=false;
    readln (OutFile,BE1);
    readln (OutFile,AA1);
    BE1G:=BE1;
    AA1G:=AA1;
    readln (OutFile,Slope34);
  end;

  if (Method>69) and (Method<>73) then
  begin
    readln (OutFile,ExponA);
    readln (OutFile,ExponB);
    readln (OutFile,SlopeA);
    readln (OutFile,InterA);
    readln (OutFile,SlopeB);
    readln (OutFile,InterB);
    readln (OutFile,Bpoint);
    if Method=70 then Bpoint70:=Bpoint;
    if Method=71 then Bpoint71:=Bpoint;
    if Method=72 then Bpoint72:=Bpoint;
  end;
  if Method=73 then
  begin
    readln (OutFile,BoundL);
    readln (OutFile,BB1);
    readln (OutFile,BB2);
    readln (OutFile,Expon73A);
    readln (OutFile,Expon73B);
    BB1G:=BB1;
    BB2G:=BB2;
    BoundL2:=BoundL;
    BoundLG:=BoundL;
  end;

  readln (OutFile,Minim);
  closefile (OutFile);
  DMCumFreq.FileName := ChangeFileExt (DMCumFreq.FileName,'.out');

    if Method=70 then
    begin
        Tmpr := exp(exponB*ln(Bpoint-Minim));
        TmpR := 1+exp(SlopeB*TmpR+InterB);
        CFBP := 1/TmpR;
    end;
    if Method=71 then                            {Composite generalized Gumbel}
    begin
      TmpR := exp(ExponB*ln(Bpoint-Minim));
      TmpR := SlopeB*TmpR+InterB;
      CFBP := exp(-exp(-TmpR));
    end;
    if Method=72 then                           {Composite generalized Poisson}
    begin
      CFBP := 1 - exp(-SlopeB*(Bpoint-Minim)+InterB);       {Poisson}
    end;

end; {TCalcForm.ReadParam}


procedure TCalcForm.CalcVal;
Var TmpR : real;
begin
    DMCumFreq.FileName:=ChangeFileExt(DMCumFreq.FileName,'.inp');
    DmCumFreq.ReadInputFile;
    DMCumFreq.FileName:=ChangeFileExt(DMCumFreq.FileName,'.out');
    ReadParam;
    NrDat:=DMCumFreq.NrOfData;
    DevSt:= (1/NrDat)*exp(0.5*ln((CumFr)*(1-(CumFr))*NrDat));
    CumFrU := CumFr + 3.4*DevSt*(1-CumFr);
    CumFrL := CumFr - 3.4*DevSt*CumFr;
    if CumFrL<0 then CumFrL:=0;
    if Method=1 then
    begin
       ValX := (CumFr-Inter)/Slope;
       ValX := exp(ln(ValX)/Exponent) + Minim;
       ValXU := (CumFrU-Inter)/Slope;
       ValXU := exp(ln(ValXU)/Exponent) + Minim;
       ValXL := (CumFrL-Inter)/Slope;
       if ValXL<=0 then ValXL:=0.001;
       ValXL := exp(ln(ValXL)/Exponent) + Minim;
    end;
    if Method=2 then
    begin
      if CumFr>0 then
      begin
         ValX := (ln(CumFr)-Inter)/Slope;
         ValX := exp(ln(ValX)/Exponent) + Minim;
      end else ValX:=MagAv + Minim;
      if CumFrU>0 then
      begin
         ValXU := (ln(CumFrU)-Inter)/Slope;
         ValXU := exp(ln(ValXU)/Exponent) + Minim;
      end else ValXU:=Xmaxi + Minim;
      if CumFrL>0 then
      begin
         ValXL := (ln(CumFrL)-Inter)/Slope;
         if ValXL<=0 then ValXL:=0.001;
         ValXL := exp(ln(ValXL)/Exponent) + Minim;
      end else ValXL:=Xmini + Minim;
    end;
    if Method=3 then
    begin
      ValX  := -(Inter+ln(1-CumFr))/Slope;
      ValX := exp(ln(ValX)/Exponent) + Minim;
      ValXU  := -(Inter+ln(1-CumFrU))/Slope;
      ValXU := exp(ln(ValXU)/Exponent) + Minim;
      ValXL  := -(Inter+ln(1-CumFrL))/Slope;
      if ValXL<=0 then ValXL:=0.001;
      ValXL := exp(ln(ValXL)/Exponent) + Minim;
    end;

    if Method=4 then
    begin
      if CumFr>0 then
         ValX  := -(ln(-ln(CumFr))+Inter)/Slope + Minim
      else
         ValX:=MagAv + Minim;
      if CumFrU>0 then
         ValXU  := -(ln(-ln(CumFrU))+Inter)/Slope + Minim
      else
         ValXU:=Xmaxi + Minim;
      if CumFr>0 then
         ValXL  := -(ln(-ln(CumFrL))+Inter)/Slope + Minim
      else
         ValXL:=Xmini + Minim;
    end;
    if Method=5 then
    begin
      ValX  := (-ln(-ln(1-CumFr))-Inter)/Slope + Minim;
      ValXU  := (-ln(-ln(1-CumFrU))-Inter)/Slope + Minim;
      ValXL  := (-ln(-ln(1-CumFrL))-Inter)/Slope + Minim;
    end;
    if Method=6 then
    begin
      ValX  := -ln(1-CumFr)/Slope;
      ValX := exp(ln(ValX)) + Minim;
      ValXU  := -ln(1-CumFrU)/Slope;
      ValXU := exp(ln(ValXU)) + Minim;
      ValXL  := -ln(1-CumFrL)/Slope;
      if ValXL<=0 then ValXL:=0.001;
      ValXL := exp(ln(ValXL)) + Minim;
    end;

    if (Method>19) and (Method<30) then
    begin
      NormalCalc(CumFr);
      if Method<22 then ValXX:=ValX + Minim + 0.001
      else ValXX:=ValX;
      NormalCalc(CumFrU);
      if Method<22 then ValXU:=ValX + Minim + 0.001
      else ValXU:=ValX;
      NormalCalc(CumFrL);
      if Method<22 then ValXL:=ValX + Minim + 0.001
      else ValXL:=ValX;
      if Method<22 then ValX:=ValXX;
    end;
    if Method=22 then                       {log normal simple}
    begin
      ValX:=exp(ValXX) + Minim;
      ValXU:=exp(ValXU) + Minim;
      ValXL:=exp(ValXL) + Minim;
    end;
    if Method=23 then                       {log normal refined}
    begin
      ValX:=exp(ValXX) + Minim;
      ValXU:=exp(ValXU) + Minim;
      ValXL:=exp(ValXL) + Minim;
    end;
    if Method=24 then                       {root normal}
    begin
      ValX:=sqr(ValXX) + Minim;
      ValXU:=sqr(ValXU) + Minim;
      ValXL:=sqr(ValXL) + Minim;
    end;
    if Method=25 then                       {sq. normal}
    begin
      ValX:=sqrt(ValXX) + Minim;
      ValXU:=sqrt(ValXU) + Minim;
      ValXL:=sqrt(ValXL) + Minim;
    end;
    if Method=26 then                       {exp. normal}
    begin
      ValX:=exp(ln(ValXX)/Exponent) + Minim;
      ValXU:=exp(ln(ValXU)/Exponent) + Minim;
      if ValXL<=0 then ValXL:=0.001;
      ValXL:=exp(ln(ValXL)/Exponent) + Minim;
    end;

    if Method=31 then                             {Burr}
    begin
      TmpR := -ln(1-CumFr)/Slope31;
      TmpR := exp(TmpR)-1;
      if TmpR<0 then TmpR:=-TmpR;
      TmpR := exp(ln(TmpR)/AA1B);
      ValX:=BE1B*TmpR+Minim;
      TmpR := -ln(1-CumFrL)/Slope31;
      TmpR := exp(TmpR)-1;
      if TmpR<0 then TmpR:=-TmpR;
      TmpR := exp(ln(TmpR)/AA1B);
      VaLXL:=BE1B*TmpR+Minim;
      TmpR := -ln(1-CumFrU)/Slope31;
      TmpR := exp(TmpR)-1;
      if TmpR<0 then TmpR:=-TmpR;
      TmpR := exp(ln(TmpR)/AA1B);
      ValXU:=BE1B*TmpR+Minim;
    end;

(*
    if Method=31 then                                   {Burr}
    begin
      TmpR := (ln(1-CumFr)-Bur)/Slope31;
      TmpR := - Inter31 + Inter31/exp(TmpR);
      ValX := exp(ln(TmpR)/AA1)+Minim;
      TmpR := (ln(1-CumFrL)-Bur)/Slope31;
      TmpR := - Inter31 + Inter31/exp(TmpR);
      ValXL := exp(ln(TmpR)/AA1)+Minim;
      TmpR := (ln(1-CumFrU)-Bur)/Slope31;
      TmpR := - Inter31 + Inter31/exp(TmpR);
      ValXU := exp(ln(TmpR)/AA1)+Minim;
    end;
*)
    if Method=32 then                                   {Dagum}
    begin
      TmpR := (ln(CumFr)-Dag)/Slope32;
      TmpR := - Inter32 + Inter32/exp(TmpR);
      ValX := exp(ln(TmpR)/AA1)+Minim;
      TmpR := (ln(CumFrL)-Dag)/Slope32;
      TmpR := - Inter32 + Inter32/exp(TmpR);
      ValXL := exp(ln(TmpR)/AA1)+Minim;
      TmpR := (ln(CumFrU)-Dag)/Slope32;
      TmpR := - Inter32 + Inter32/exp(TmpR);
      ValXU := exp(ln(TmpR)/AA1)+Minim;
    end;

    if Method=34 then                                   {Compertz}
    begin
      TmpR :=ln(1-CumFr)/Slope34;
      TmpR:=ln(TmpR+1)/BE1G;
      ValX:=exp(TmpR/AA1G)+Minim;
      if Small then ValX:=ValX-1;
      TmpR :=ln(1-CumFrL)/Slope34;
      TmpR:=ln(TmpR+1)/BE1G;
      VaLXL:=exp(TmpR/AA1G)+Minim;
      if Small then ValXL:=ValXL-1;
      TmpR :=ln(1-CumFrU)/Slope34;
      TmpR:=ln(TmpR+1)/BE1G;
      ValXU:=exp(TmpR/AA1G)+Minim;;
      if Small then ValXU:=ValXU-1;
    end;

    if Method=36 then                                   {Kumaraswamy}
    begin
      TmpR:=(ln(1-CumFr))/Slope36;
      TmpR:=exp(TmpR);
      TmpR:=1-TmpR;
      ValX:=MaxVal*exp((1/Expon36)*ln(TmpR))+Minim;
      TmpR:=(ln(1-CumFrL))/Slope36;
      TmpR:=exp(TmpR);
      TmpR:=1-TmpR;
      ValXL:=MaxVal*exp((1/Expon36)*ln(TmpR))+Minim;
      TmpR:=(ln(1-CumFrU))/Slope36;
      TmpR:=exp(TmpR);
      TmpR:=1-TmpR;
      ValXU:=MaxVal*exp((1/Expon36)*ln(TmpR))+Minim;
    end;

    if Method=51 then
    begin
      if CumFr>0 then
      begin
         ValX := -(ln(-ln(CumFr))+Inter)/Slope;
         ValX := exp(ln(ValX)/Exponent) + Minim;
      end
      else ValX:=MagAv + Minim;
      if CumFrU>0 then
      begin
         ValXU  := -(ln(-ln(CumFrU))+Inter)/Slope;
         ValXU := exp(ln(ValXU)/Exponent) + Minim;
      end
      else ValXU:=Xmaxi + Minim;
      if CumFr>0 then
      begin
         ValXL  := -(ln(-ln(CumFrL))+Inter)/Slope;
         if ValXL<=0 then ValXL:=0.001;
         ValXL := exp(ln(ValXL)/Exponent) + Minim;
      end
      else ValXL:=Xmini + Minim;
    end;
    if Method=52 then
    begin
      ValX  := (-ln(-ln(1-CumFr))-Inter)/Slope;
         ValX := exp(ln(ValX)/Exponent) + Minim;
      ValXU  := (-ln(-ln(1-CumFrU))-Inter)/Slope;
         ValXU := exp(ln(ValXU)/Exponent) + Minim;
      ValXL  := (-ln(-ln(1-CumFrL))-Inter)/Slope;
      if ValXL<=0 then ValXL:=0.001;
         ValXL := exp(ln(ValXL)/Exponent) + Minim;
    end;
    if Method=53 then                                   {logistic}
    begin
      ValX := (1/Slope)*(ln(1/CumFr-1)-Inter) + Minim;
      ValXU := (1/Slope)*(ln(1/CumFrU-1)-Inter) + Minim;
      ValXL := (1/Slope)*(ln(1/CumFrL-1)-Inter) + Minim;
    end;
    if Method=54 then                                   {log. logistic}
    begin
      ValX := (1/Slope)*(ln(1/CumFr-1)-Inter);
      ValX := exp(ValX) + Minim;
      ValXU := (1/Slope)*(ln(1/CumFrU-1)-Inter);
      ValXU := exp(ValXU) + Minim;
      ValXL := (1/Slope)*(ln(1/CumFrL-1)-Inter);
      ValXL := exp(ValXL) + Minim;
    end;

    if Method=55 then                                   {generalized logistic}
    begin
      ValX := (1/Slope)*(ln(1/CumFr-1)-Inter);
      ValX := exp(ln(ValX)/Exponent) + Minim;
      ValXU := (1/Slope)*(ln(1/CumFrU-1)-Inter);
      ValXU := exp(ln(ValXU)/Exponent) + Minim;
      ValXL := (1/Slope)*(ln(1/CumFrL-1)-Inter);
      if ValXL<=0 then ValXL:=0.001;
      ValXL := exp(ln(ValXL)/Exponent) + Minim;
    end;

    if Method=70 then
    begin
      if CumFr>CFBP then
      begin
        ValX:=(1/SlopeB)*(ln(1/CumFr-1)-InterB);
        ValX := exp(ln(ValX)/ExponB) + Minim;
        ValXL := (1/SlopeB)*(ln(1/CumFrL-1)-InterB);
        if ValXL<=0 then ValXL:=0.001;
        ValXL := exp(ln(ValXL)/ExponB) + Minim;
        ValXU := (1/SlopeB)*(ln(1/CumFrU-1)-InterB);
        ValXU := exp(ln(ValXU)/ExponB) + Minim;
      end else
      begin
        ValX:=(1/SlopeA)*(ln(1/CumFr-1)-InterA);
        ValX := exp(ln(ValX)/ExponA) + Minim;
        ValXL := (1/SlopeA)*(ln(1/CumFrL-1)-InterA);
        if ValXL<=0 then ValXL:=0.001;
        ValXL := exp(ln(ValXL)/ExponA) + Minim;
        ValXU := (1/SlopeA)*(ln(1/CumFrU-1)-InterA);
        ValXU := exp(ln(ValXU)/ExponA) + Minim;
      end;
    end;

    if Method=71 then
    begin
      if CumFr>CFBP then
      begin
        ValX := -(ln(-ln(CumFr))+InterB)/SlopeB;
        if ValX>0 then
           ValX := exp(ln(ValX)/ExponB) + Minim;
         ValXL := -(ln(-ln(CumFrL))+InterB)/SlopeB;
         if ValXL<=0 then ValXL:=0.001;
         ValXL := exp(ln(ValXL)/ExponB) + Minim;
         ValXU := -(ln(-ln(CumFrU))+InterB)/SlopeB;
         if ValXU>0 then
            ValXU := exp(ln(ValXU)/ExponB) + Minim;
      end else
      begin
        ValX := -(ln(-ln(CumFr))+InterA)/SlopeA;
        if ValX>0 then
           ValX := exp(ln(ValX)/ExponA) + Minim;
         ValXL := -(ln(-ln(CumFrL))+InterA)/SlopeA;
         if ValXL<=0 then ValXL:=0.001;
         ValXL := exp(ln(ValXL)/ExponA) + Minim;
         ValXU := -(ln(-ln(CumFrU))+InterA)/SlopeA;
         if ValXU>0 then
            ValXU := exp(ln(ValXU)/ExponA) + Minim;
      end;
    end;

    if Method=72 then
    begin
      if CumFr>CFBP then
      begin
        ValX  := (-1/SlopeB)*(ln(1-CumFr)+InterB);       {Poisson}
        ValX  := exp(ln(ValX)/ExponB) + Minim;
        ValXU := (-1/SlopeB)*(ln(1-CumFrU)+InterB);
        ValXU := exp(ln(ValXU)/ExponB) + Minim;
        ValXL := (-1/SlopeB)*(ln(1-CumFrL)+InterB);
        if ValXL<=0 then ValXL:=0.001;
        ValXL := exp(ln(ValXL)/ExponB) + Minim;
      end else
      begin
        ValX  := (-1/SlopeA)*(ln(1-CumFr)+InterA);       {Poisson}
        ValX  := exp(ln(ValX)/ExponA) + Minim;
        ValXU := (-1/SlopeA)*(ln(1-CumFrU)+InterA);
        ValXU := exp(ln(ValXU)/ExponA) + Minim;
        ValXL := (-1/SlopeA)*(ln(1-CumFrL)+InterA);
        if ValXL<=0 then ValXL:=0.001;
        ValXL := exp(ln(ValXL)/ExponA) + Minim;
      end;
    end;

    if Method=56 then                                   {Fisk}
    begin
      TmpR:=ln(1/(1-CumFr) -1);
      ValX := exp ( TmpR/Slope +ln (Inter));
      TmpR:=ln(1/(1-CumFrU) -1);
      VaLXU := exp ( TmpR/Slope +ln (Inter));
      TmpR:=ln(1/(1-CumFrL) -1);
      ValXL := exp ( TmpR/Slope +ln (Inter));
    end;
    if Method=57 then                                   {Weibull}
    begin
      ValX  := exp((ln(-ln(1-CumFr))-Inter)/Slope) + Minim;
      ValXU  := exp((ln(-ln(1-CumFrU))-Inter)/Slope) + Minim;
      ValXL  := exp((ln(-ln(1-CumFrL))-Inter)/Slope) + Minim;
    end;
    if Method=58 then                                   {Frechet}
    begin
      if CumFr>0 then
        ValX := exp(-Inter/Slope)*exp((1/Slope)*ln(-ln(CumFr)))
                + Bound
      else ValX:=Bound ;
      if CumFrU>0 then
         ValXU := exp(-Inter/Slope)*exp((1/Slope)*ln(-ln(CumFrU)))
                  + Bound
      else ValXU:=Bound;
      if CumFrL>0 then
         ValXL := exp(-Inter/Slope)*exp((1/Slope)*ln(-ln(CumFrL)))
                  + Bound
      else ValXL:=Bound;
    end;
    if Method=33 then                                {Fisher-Tippet III mirr.}
    begin
      if CumFr>0 then
        ValX := Bound-exp(-Inter/Slope)*exp((1/Slope)*ln(-ln(1-CumFr)))
      else ValX:= Bound;
      if CumFrU>0 then
         ValXU := Bound-exp(-Inter/Slope)*exp((1/Slope)*ln(-ln(1-CumFrU)))
      else ValXU:=Bound;
      if CumFrL>0 then
         ValXL := Bound-exp(-Inter/Slope)*exp((1/Slope)*ln(-ln(1-CumFrL)))
      else ValXL:=Bound;
    end;
   if Method=35 then                                   {Frechet mirr.}
    begin
      if CumFr>0 then
        ValX := exp(-Inter/Slope)*exp((1/Slope)*ln(-ln(1-CumFr)))
                + Bound
      else ValX:=Bound;
      if CumFrU>0 then
         ValXU := exp(-Inter/Slope)*exp((1/Slope)*ln(-ln(1-CumFrU)))
                  + Bound
      else ValXU:=Bound;
      if CumFrL>0 then
         ValXL := exp(-Inter/Slope)*exp((1/Slope)*ln(-ln(1-CumFrL)))
                  + Bound
      else ValXL:=Bound;
    end;
     if Method=59 then                                   {Fisher-Tippet III}
    begin
      if CumFr>0 then
        ValX := Bound-exp(-Inter/Slope)*exp((1/Slope)*ln(-ln(CumFr)))
      else ValX:= Minim;
      if CumFrU>0 then
         ValXU := Bound-exp(-Inter/Slope)*exp((1/Slope)*ln(-ln(CumFrU)))
      else ValXU:=Minim;
      if CumFrL>0 then
         ValXL := Bound-exp(-Inter/Slope)*exp((1/Slope)*ln(-ln(CumFrL)))
      else ValXL:=Minim;
    end;
    if Method=60 then                                   {Mirr. Weibull}
    begin
      ValX  := exp((ln(-ln(CumFr))-Inter)/Slope) + Minim;
      ValXU  := exp((ln(-ln(CumFrU))-Inter)/Slope) + Minim;
      ValXL  := exp((ln(-ln(CumFrL))-Inter)/Slope) + Minim;
    end;
    if Method=62 then                               {Student's with d.f.=1}
    begin
      ValX  := tan(pi*(CumFr-0.5));
         ValX:= StDev*ValX + MagAv;
      VaLXU  := tan(pi*(CumFrU-0.5));
         VaLXU:=StDev*VaLXU + MagAv;
      ValXL  := tan(pi*(CumFrL-0.5));
         ValXL:=StDev*ValXL + MagAv;
    end;
    if Method=63 then                               {Student's with d.f.=2}
    begin
      ValX := sqrt(2)*(2*CumFr-1);
      ValX := ValX/sqrt(1-sqr(2*CumFr-1));
         ValX := StDev*ValX + MagAv;
      ValXU := sqrt(2)*(2*CumFrU-1);
      ValXU := ValXU/sqrt(1-sqr(2*CumFrU-1));
         VaLXU := StDev*ValXU + MagAv;
      ValXL := sqrt(2)*(2*CumFrL-1);
      ValXL := ValXL/sqrt(1-sqr(2*CumFrL-1));
         ValXL := StDev*ValXL + MagAv;
    end;
    if Method=64 then
    begin
      ValX := (tan(pi*(CumFr-0.5))-Inter)/Slope + Minim;
      ValXU := (tan(pi*(CumFrU-0.5))-Inter)/Slope + Minim;
      ValXL := (tan(pi*(CumFrL-0.5))-Inter)/Slope + Minim;
    end;
    if Method=65 then
    begin
      ValX := (tan(pi*(CumFr-0.5))-Inter)/Slope;
         ValX:=exp(ln(ValX)/Exponent) + Minim;
      ValXU := (tan(pi*(CumFrU-0.5))-Inter)/Slope;
         ValXU:=exp(ln(ValXU)/Exponent) + Minim;
      ValXL := (tan(pi*(CumFrL-0.5))-Inter)/Slope;
      if ValXL<=0 then ValXL:=0.001;
         ValXL:=exp(ln(ValXL)/Exponent) + Minim;
    end;
    if Method=66 then
    begin
      ValX  := -(Inter+ln(CumFr))/Slope;
      ValX := exp(ln(ValX)/Exponent) + Minim;
      ValXU  := -(Inter+ln(CumFrU))/Slope;
      ValXU := exp(ln(ValXU)/Exponent) + Minim;
      ValXL  := -(Inter+ln(CumFrL))/Slope;
      if ValXL<=0 then ValXL:=0.001;
      ValXL := exp(ln(ValXL)/Exponent) + Minim;
    end;
    if Method=67 then
    begin
      ValX:=-Exponent*ln(-ln(CumFr));
      ValX:=StE*(exp(ValX)-1)/Exponent+Ave+Minim;
      ValXU:=-Exponent*ln(-ln(CumFrU));
      ValXU:=StE*(exp(ValXU)-1)/Exponent+Ave+Minim;
      ValXL:=-Exponent*ln(-ln(CumFrL));
      ValXL:=StE*(exp(ValXL)-1)/Exponent+Ave+Minim;
    end;
    if Method=68 then
    begin
      if CumFr<0.5 then
         ValX := BB1*ln(2*CumFr)+BoundL+Minim
      else
         ValX := -BB2*ln(2-2*CumFr)+BoundL+Minim;
      if CumFrU<0.5 then
         ValXU := BB1*ln(2*CumFrU)+BoundL+Minim
      else
         ValXU := -BB2*ln(2-2*CumFrU)+BoundL+Minim;
      if CumFrL<0.5 then
         ValXL := BB1*ln(2*CumFrL)+BoundL+Minim
      else
         ValXL := -BB2*ln(2-2*CumFrL)+BoundL+Minim;
    end;
    if Method=69 then
    begin
      TmpR  := -ln(1-CumFr)*Slope69;
      ValX  := exp(ln(TmpR)/Expon69) + Minim;
      TmpR  := -ln(1-CumFrU)*Slope69;
      ValXU := exp(ln(TmpR)/Expon69) + Minim;
      TmpR  := -ln(1-CumFrL)*Slope69;
      ValXL := exp(ln(TmpR)/Expon69) + Minim;
    end;
    if Method=73 then
    begin
      BoundL:=exp(Expon73A*ln(BoundL));
      if CumFr<0.5 then
      begin
         ValX := BB1*ln(2*CumFr)+BoundL;
         ValX:=exp(ln(ValX)/Expon73A) + Minim;
      end else
      begin
         ValX := -BB2*ln(2-2*CumFr)+BoundL;
         ValX:=exp(ln(ValX)/Expon73B) + Minim;
      end;
      if CumFrU<0.5 then
      begin
         ValXU := BB1*ln(2*CumFrU)+BoundL;
         ValXU:=exp(ln(ValXU)/Expon73A) + Minim;
      end else
      begin
         ValXU := -BB2*ln(2-2*CumFrU)+BoundL;
         ValXU:=exp(ln(ValXU)/Expon73B) + Minim;
      end;
      if CumFrL<0.5 then
      begin
         ValXL := BB1*ln(2*CumFrL)+BoundL;
         if ValXL<=0 then ValXL:=0.001;
         ValXL:=exp(ln(ValXL)/Expon73A) + Minim;
      end else
      begin
         ValXL := -BB2*ln(2-2*CumFrL)+BoundL;
         if ValXL<=0 then ValXL:=0.001;
         ValXL:=exp(ln(ValXL)/Expon73B) + Minim;
      end;
    end;

end;
{end of CalcValues}
{-----------------}


procedure TCalcForm.NormalCalc (CumulFreq:real);

var AuxVar,NwFreq,Term1,Term2,Term3,Term4,Term5,TermSum : real;
    XX, MagRed, MagTrf, MagTrSq : real;
    ii:integer;

begin

  DMCumFreq.FileName:=ChangeFileExt(DMCumFreq.FileName,'.inp');
  DmCumFreq.ReadInputFile;
  DMCumFreq.FileName:=ChangeFileExt(DMCumFreq.FileName,'.out');
  ReadParam;
  MaxMin;                                                {required for Xmaxi}

  for ii:=1 to 100000 do
  begin
    XX        := Xmini+0.0001*Xmaxi*ii;
    MagRed    := (XX-MagAv)/StDev;
    MagTrf    := 1/(1+0.23165*MagRed);
    MagTrSq   := MagTrf*MagTrf;
    Term1     := 0.31938*MagTrf;
    Term2     :=-0.35656*MagTrSq;
    Term3     := 1.78148*MagTrf*MagTrSq;
    Term4     :=-1.82126*MagTrSq*MagTrSq;
    Term5     := 1.33027*MagTrf*MagTrSq*MagTrSq;
    TermSum   := Term1+Term2+Term3+Term4+Term5;
    AuxVar    := exp(-MagRed*MagRed/2)/sqrt(2*Pi);
    if TermSum<0 then NwFreq:=0
       else NwFreq := 1-AuxVar*TermSum;
    if NwFreq>CumulFreq then
    begin
      ValX:=XX;
      exit;
    end;
  end;
end;  {TCalcForm.NormalCalc}


procedure TCalcForm.MaxMin;
var ii : integer;

begin
  Xmaxi:=-1000000;
  Xmini:=1000000;
  setlength (DMCumFreq.DataValue,DmCumFreq.NrOfData+1);
  for ii:=0 to DMCumfreq.NrOfData-1 do with DMCumFreq do
  begin
    DataValue[ii]:=DataValue[ii]-Minim+0.001;
    if DataValue[ii]>Xmaxi  then Xmaxi := DataValue[ii];
    if DataValue[ii]<Xmini  then Xmini := DataValue[ii];
  end;

  if Method>21 then
  begin
    Xmaxi:=-1000000;
    Xmini:=1000000;
  end;

  if Method>21 then
  for ii:=0 to DMCumfreq.NrOfData-1 do with DMCumFreq do
  begin
    if Method=22 then DataValue[ii]:=ln(Datavalue[ii]);
    if Method=23 then DataValue[ii]:=ln(Datavalue[ii]);
    if Method=24 then DataValue[ii]:=sqrt(Datavalue[ii]);
    if Method=25 then DataValue[ii]:=sqr(Datavalue[ii]);
    if Method=26 then DataValue[ii]:=exp(Exponent*ln(Datavalue[ii]));
      if DataValue[ii]>Xmaxi  then Xmaxi := DataValue[ii];
      if DataValue[ii]<Xmini  then Xmini := DataValue[ii];
  end;
end;
{end of MaxMin}
{-------------}


procedure TCalcForm.FormHide(Sender: TObject);
var DataQuan:integer;
begin
  if MainForm.InputOpened then
  begin
    DMCumFreq.FileName:=ChangeFileExt(DMCumFreq.FileName,'.inp');
    DMCumFreq.ReadInputFile;
    DataQuan:=DMCumfreq.NrOfData-1;
    MainForm.ShowData(DataQuan);
  end;
  Edit1.Text:='';
  Edit2.Text:='';
  Edit3.Text:='';
  Edit4.Text:='';
  Edit5.Text:='';
  Edit6.Text:='';
  Edit9.Text:='';
  Edit10.Text:='';
  Edit11.Text:='';
  Edit12.Text:='';
  Edit13.Text:='';
  Edit14.Text:='';
end; {TCalcForm.FormHide}


procedure TCalcForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Edit1.Text:='';
  Edit2.Text:='';
  Edit3.Text:='';
  Edit4.Text:='';
  Edit5.Text:='';
  Edit6.Text:='';
  Edit9.Text:='';
  Edit10.Text:='';
  Edit11.Text:='';
  Edit12.Text:='';
  Edit13.Text:='';
  Edit14.Text:='';
end;

procedure TCalcForm.Edit1Enter(Sender: TObject);
begin
  Edit1.Text:='';
  Edit2.Text:='';
  Edit3.Text:='';
  Edit13.Text:='';
  Edit14.Text:='';
  Edit9.Text:='';
  Edit10.Text:='';
end;

procedure TCalcForm.Edit4Enter(Sender: TObject);
begin
  Edit4.Text:='';
  Edit5.Text:='';
  Edit6.Text:='';
  Edit11.Text:='';
  Edit12.Text:='';
end;

procedure TCalcForm.Edit5Enter(Sender: TObject);
begin
  Edit4.Text:='';
  Edit5.Text:='';
  Edit6.Text:='';
  Edit11.Text:='';
  Edit12.Text:='';
end;




end.
